import { compilerVersion, svelteVersion } from "./svelte-version.js";
export function isEnableRunes(svelteConfig, parserOptions) {
    if (!svelteVersion.gte(5))
        return false;
    if (parserOptions.svelteFeatures?.runes != null) {
        return Boolean(parserOptions.svelteFeatures.runes);
    }
    if (svelteConfig?.compilerOptions?.runes != null) {
        return Boolean(svelteConfig.compilerOptions.runes);
    }
    return true;
}
export function resolveSvelteParseContextForSvelte(svelteConfig, parserOptions, svelteAst) {
    const svelteOptions = svelteAst.options;
    if (svelteOptions?.runes != null) {
        return {
            runes: svelteOptions.runes,
            compilerVersion,
            svelteConfig,
        };
    }
    return {
        runes: isEnableRunes(svelteConfig, parserOptions),
        compilerVersion,
        svelteConfig,
    };
}
export function resolveSvelteParseContextForSvelteScript(svelteConfig, parserOptions) {
    return resolveSvelteParseContext(svelteConfig, parserOptions);
}
function resolveSvelteParseContext(svelteConfig, parserOptions) {
    return {
        runes: isEnableRunes(svelteConfig, parserOptions),
        compilerVersion,
        svelteConfig,
    };
}
